﻿using ff14bot;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Objects;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;

namespace Eclipse.HealBot
{
    public static class EC
    {
        public static GameObject Tank;
        public static Needy needy = new Needy { Obj = Core.Player };
        public static string ilog = string.Empty;
        public static bool InParty = false;
        #region Helper Methods
        public static void log(string text)
        {
            Logging.Write(Color.FromRgb(0,255,255), "Eclipse=>" + text);
        }
        public static void iLog(string text)
        {
            ilog += (string.Format("Eclipse | {0:MM-dd-yy hh:mm:ss} => {1} \r\n", DateTime.Now, text));
            log(text);
        }
        public static double Distance(float[] loc1, float[] loc2)
        {
            return Math.Sqrt(loc1.Zip(loc2, (a, b) => (a - b) * (a - b)).Sum());
        }
        public static string WebRequest(string url)
        {
            HttpWebRequest webRequest = null;
            string responseData = string.Empty;

            webRequest = System.Net.WebRequest.Create(url) as HttpWebRequest;
            webRequest.Method = "GET";
            webRequest.ServicePoint.Expect100Continue = false;
            webRequest.Timeout = 200000;
            responseData = WebResponseGet(webRequest);
            webRequest = null;
            return responseData;
        }
        public static string WebResponseGet(HttpWebRequest webRequest)
        {
            StreamReader responseReader = null;
            string responseData = string.Empty;
            try
            {
                responseReader = new StreamReader(webRequest.GetResponse().GetResponseStream());
                responseData = responseReader.ReadToEnd();
            }
            catch (Exception)
            {
                throw;
            }
            finally
            {
                webRequest.GetResponse().GetResponseStream().Close();
                responseReader.Close();
                responseReader = null;
            }
            return responseData;
        }
        public static bool FindNeedy()
        {
            if (PartyManager.IsInParty)
            {
                InParty = true;
                PartyMember member = PartyManager.VisibleMembers.Where(p => HealthPercent(p.CurrentHealth, p.MaxHealth) < 95).OrderBy(p => HealthPercent(p.CurrentHealth, p.MaxHealth)).FirstOrDefault();
                if (member == null) return false;
                else
                {
                    Needy needy = new Needy();
                    needy.CurrentHealthPercent = HealthPercent(member.CurrentHealth, member.MaxHealth);
                    needy.CurrentManaPercent = HealthPercent(member.CurrentMana, member.MaxMana);
                    needy.Obj = member.GameObject;
                    needy.Obj.Target();
                    EC.needy = needy;
                    return true;
                }
            }
            else
            {
                InParty = false;
                if (Core.Player.CurrentHealthPercent < 90)
                {
                    Needy needy = new Needy();
                    needy.CurrentHealthPercent = Core.Player.CurrentHealthPercent;
                    needy.CurrentManaPercent = Core.Player.CurrentManaPercent;
                    needy.Obj = Core.Player;
                    needy.Obj.Target();
                    EC.needy = needy;
                    return true;
                }
                return false;


            }

            
        }
        public static bool WhosTheTank()
        {
            GameObject tank = null;
            if (PartyManager.NumMembers > 2) tank  = PartyManager.VisibleMembers.OrderByDescending(p => p.MaxHealth).FirstOrDefault().GameObject;
            if (PartyManager.NumMembers == 2) tank = PartyManager.VisibleMembers.Where(p => !p.IsMe).FirstOrDefault().GameObject;
            if (PartyManager.NumMembers == 1) tank = GameObjectManager.LocalPlayer;
            if (tank != null)
            {
                if (tank != null)
                {
                    log("Found the tank: " + tank.Name + " out of " + PartyManager.NumMembers.ToString() + " party members." );
                    Tank = tank;
                    return true;
                }
            }
            return true;
            
        }
        public static double HealthPercent(uint current, uint max)
        {

           // log("health percent is " + (current / max * 100).ToString());
            return (current / max * 100);
        }
        #endregion
    }
}