﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.AClasses;
using ff14bot.Behavior;
using System.Windows.Forms;
using Action = TreeSharp.Action;
using Eclipse.HealBot;
using ff14bot.Objects;
using Clio.Utilities;
using TreeSharp;

namespace Eclipse.HealBot
{
    public class Eclipse_HealBot : BotBase
    {
        Profile profile = new Profile();
        private bool ForceNav = true;
        private Vector3 NavLocation = Vector3.Zero;
        AStarNavigator nav = new AStarNavigator();
        public override string Name
        {
            get { return "Eclipse - HealBot"; }
        }
        public static ff14bot.Objects.LocalPlayer Me { get; set; }

        public override bool WantButton
        {
            get
            {
                return true;
            }
        }

        private EclipseConfig settings;
        public override void OnButtonPress()
        {
            if (settings == null || settings.IsDisposed)
                settings = new EclipseConfig();
            try
            {
                settings.Show();
                settings.Activate();
            }
            catch (ArgumentOutOfRangeException ee)
            {

            }
        }
        public override void Start()
        {
            Navigator.PlayerMover = new TwistSlideMover();
            profile.graph = new Pathfinding.Graph();
            Navigator.NavigationProvider = new AStarNavigator(profile.graph);
            GameSettingsManager.FaceTargetOnAction = true;
            
            RoutineManager.Current = RoutineManager.Routines.Where(r => r.Name.Contains("Eclipse")).FirstOrDefault();
            EC.log(RoutineManager.Current.Name);
            if (PartyManager.NumMembers > 0) EC.WhosTheTank();
            else Stop();
        }

        public override void Stop()
        {
            EC.Tank = null;
            EC.needy = null;
        }

        public override PulseFlags PulseFlags
        {
            get { return PulseFlags.All; }
        }
        public override bool RequiresProfile
        {
            get { return false; }
        }
        private Composite _root;

        public override Composite Root
        {
            get
            {
                return _root ?? (_root =
                    new PrioritySelector(
                        //new Sequence(new Action(ret => EC.log("Started Tree")), new ActionAlwaysFail()),
                        new Decorator(ret => Me == null, new Action(r => Me = Core.Player)),
                        //new Sequence(new Action(ret=>EC.log("After player assigment")),new ActionAlwaysFail()),
                        new Decorator(ret=> Me.InCombat && EC.FindNeedy(),
                            new PrioritySelector(
                                    new Decorator(ret => EC.needy.Obj.Distance2D() <= 20, 
                                        new PrioritySelector(
                                            new Sequence(
                                                new Action(ret=>Navigator.PlayerMover.MoveStop()), 
                                                new ActionAlwaysFail()),
                                            RoutineManager.Current.HealBehavior
                                        )),
                                new Decorator(ret => EC.needy.Obj.Distance2D() > 20, new Action(ret => Navigator.PlayerMover.MoveTowards(EC.needy.Obj.Location)))
                        )),
                        new Decorator(ret => Me.InCombat && EC.needy != null, RoutineManager.Current.HealBehavior),
                        new Decorator(ret=> !Me.InCombat && EC.Tank != null,
                            new PrioritySelector(
                                //new Sequence(new Action(ret => EC.log("Not in combat and tank != null")), new ActionAlwaysFail()),
                                RoutineManager.Current.CombatBuffBehavior,
                                new Decorator(ret => EC.Tank.Distance2D() > 10, 
                                        new Sequence(
                                            new Action(r=>Navigator.PlayerMover.MoveTowards(EC.Tank.Location)),
                                            new ActionAlwaysFail()
                                        )),
                                new Decorator(ret => EC.Tank.Distance2D() <= 5, new Action(r => Navigator.PlayerMover.MoveStop())),
                                //new Decorator(ret=> EC.Tank == GameObjectManager.LocalPlayer, new Action(r=>EC.log("It's ME!"))),
                                new ActionAlwaysFail()
                            )),
                        new Decorator(ret => !Me.InCombat && EC.FindNeedy(), 
                            new PrioritySelector(
                                    new Decorator(ret=> EC.Tank == GameObjectManager.LocalPlayer, new Action(r=>EC.log("It's ME!")))
                                ))

                    ));
            }
        }
    }
}
